/*
 *  cOptFlow.h
 *  extractMotionHistogram
 *
 *  Created by Kris Kitani on 5/25/11. (kkitani@cs.cmu.edu)
 *  Copyright 2011 Kris Kitani. All rights reserved.
 *
 */

#ifndef OPTICAL_FLOW_H
#define OPTICAL_FLOW_H

#include <opencv2/opencv.hpp>

class cOptFlow{
public:
	
	cOptFlow(){};
	~cOptFlow(){};
	
	void init(int maxCount);
	int trackPoints(IplImage* gry);
	void getCurrentTrackedPoints (CvPoint2D32f **);
	void getPreviousTrackedPoints (CvPoint2D32f **);	
	void getCount(int *);

	int m_maxCount;
	float m_minEigen;

	int count;
	CvPoint2D32f *pts_cur;			// current set of corners
	CvPoint2D32f *pts_prv;			// previous set of corners
	CvPoint2D32f *pts_cur_trk;
	CvPoint2D32f *pts_prv_trk;
	
private:
	
	IplImage *eig, *tmp, *stmp, *pgry,*pyr,*ppyr;
	IplImage *t;
	int win_size;
	
	CvPoint2D32f *spts, *tpts;
	char *stat;

	int flags ;
	double quality;
	double min_distance;
	int avg_blocksize;
	int pcount;
	int i,j,k;
		
};

#endif